----------------------------------------------------------------------------------
--
-- scenetemplate.lua
--
----------------------------------------------------------------------------------

local storyboard = require( "storyboard" )
local scene = storyboard.newScene()

local widget = require("widget")

local group2

local totaltime
local score

local totaltimeTxt
local scoreTxt
local totalscoreTxt

local finalscoreImage
local totaltimeImage
local scoreImage
local myScoreImage

local str
local xDimen
local yDimen
local previousX

local ads = require "ads"

--typeOfPlay
----------------------------------------------------------------------------------
-- 
--	NOTE:
--	
--	Code outside of listener functions (below) will only be executed once,
--	unless storyboard.removeScene() is called.
-- 
---------------------------------------------------------------------------------

--local sndNoMatch = audio.loadSound("audio/nomatch.mp3")
--local sndMatch = audio.loadSound("audio/match.mp3")
--local sndWinner = audio.loadSound("audio/winner.mp3")

-- in a module where fullscreen ads are to be displayed
    local isSimulator = system.getInfo("environment") == "simulator"
    local function testNetworkConnection()
        local netConn = require('socket').connect('www.apple.com', 80)
        if netConn == nil then
            return false
        end
        netConn:close()
        return true
    end
	
		
local function startAgain(e)	
	storyboard.purgeScene("play")
	storyboard.removeScene("play")
	
	storyboard.gotoScene( "play",  {time=100, effect="flipFadeOutIn"})
end

local function goToMainMenu(e)
	storyboard.purgeScene("play")
	storyboard.removeScene("play")
	
	
	--storyboard.gotoScene( "selecttypeofplay")
	storyboard.gotoScene( "selecttypeofplay", {time=100, effect="flipFadeOutIn"})
	--storyboard.gotoScene( "selectdimention", {time=100, effect="flipFadeOutIn"})
	
end


local function setImage()
	for i = 1, #str do
		
		local currentX
		
		local c = str:sub(i,i)
		-- do something with c
		--print("c: " .. tostring(c))
			if c == "1" then
				myScoreImage = display.newImageRect("images/newimages/" .. c .. ".png", 19, 35)
				currentX = 19
			elseif (c == "2") or (c == "6") or (c == "7") or (c == "8") or (c == "9") or (c == "0") then	
				myScoreImage = display.newImageRect("images/newimages/" .. c .. ".png", 24, 35)
				currentX = 24
			elseif (c == "3") or (c == "5") then	
				myScoreImage = display.newImageRect("images/newimages/" .. c .. ".png", 25, 35)
				currentX = 25
			elseif (c == "4") then
				myScoreImage = display.newImageRect("images/newimages/" .. c .. ".png", 26, 35)
				currentX = 26
			end
			
			if i == 1 then
				previousX = xDimen
			else
				--previousX = previousX
			end
			--print("i: " .. tostring(i))
			--print("previousX: " .. tostring(previousX))
			--print("currentX: " .. tostring(currentX))
			
			myScoreImage.x = previousX + currentX
			
			previousX = previousX + currentX
			
			myScoreImage.y = yDimen
			group2:insert(myScoreImage)
			
			--print("myScoreImage.x: " .. tostring(myScoreImage.x))
			--print("myScoreImage.y: " .. tostring(myScoreImage.y))
	end
end
---------------------------------------------------------------------------------
-- BEGINNING OF YOUR IMPLEMENTATION
---------------------------------------------------------------------------------

-- Called when the scene's view does not exist:
function scene:createScene( event )
	local group = self.view
	
	
	-----------------------------------------------------------------------------
		
	--	CREATE display objects and add them to 'group' here.
	--	Example use-case: Restore 'group' from previously saved state.
	
	-----------------------------------------------------------------------------

	local prior_scene = storyboard.getPrevious()
	storyboard.purgeScene( prior_scene )
	
	
	storyboard.purgeScene("play")
	storyboard.removeScene("play")
	
	
	local showAds = math.random( 0, 1 )
	if showAds == 0 then
		
		if ( isSimulator or not testNetworkConnection() ) then
			print("on simulator or no network connection, and therefore, no fullscreen ads")
		else
				local function adListener( event )
					if event.isError then
						-- Failed to receive an ad.
					end
				end

				ads.init( "admob", "ca-app-pub-9562809720714816/7018383285", adListener )
				ads.show( "interstitial", { x=0, y=0 } )
		end
	end 
	
	
	
	playagainImage = display.newText( "Play Again", 40, 20, "PAETRI", 24 )
	playagainImage.x = centerX
	playagainImage.y = 260
	playagainImage:addEventListener( "tap", startAgain)
	group:insert(playagainImage)
	
	
	mainmenuImage = display.newText( "Main Menu", 40, 20, "PAETRI", 24 )
	mainmenuImage.x = centerX
	mainmenuImage.y = 340
	mainmenuImage:addEventListener( "tap", goToMainMenu)
	group:insert(mainmenuImage)
	
	 
	totaltimeImage = display.newText( "Total Time: ", 40, 20, "PAETRI", 24 )
	totaltimeImage.x = centerX
	totaltimeImage.y = 80
	group:insert(totaltimeImage)
	
	
	scoreImage = display.newText( "Score: ", 40, 20, "PAETRI", 24 )
	scoreImage.x = centerX
	scoreImage.y = 130
	group:insert(scoreImage)

	
	finalscoreImage = display.newText( "Final Score: ", 40, 20, "PAETRI", 24 )
	finalscoreImage.x = centerX
	finalscoreImage.y = 180
	group:insert(finalscoreImage)
	

	 
end


-- Called immediately after scene has moved onscreen:
function scene:enterScene( event )
	local group = self.view
	group2 = group
	-----------------------------------------------------------------------------
		
	--	INSERT code here (e.g. start timers, load audio, start listeners, etc.)
	
	-----------------------------------------------------------------------------
	
	--print("Enterd");
	
	
	local params = event.params

	totaltime = params.totalTime
	score = params.score

	str = tostring(totaltime)
	xDimen = totaltimeImage.x + totaltimeImage.width/2
	yDimen = totaltimeImage.y
	totaltimeImage.text = totaltimeImage.text .. str
	--setImage()
	
	
	--totaltimeTxt.text = tostring(totaltime)
	
	str = tostring(score)
	xDimen = scoreImage.x + scoreImage.width/2
	yDimen = scoreImage.y
	scoreImage.text = scoreImage.text .. str
	--setImage()
	
	
	str = tostring(score - totaltime)
	xDimen = finalscoreImage.x + finalscoreImage.width/2
	yDimen = finalscoreImage.y
	finalscoreImage.text = finalscoreImage.text .. str
	--setImage()
	
	
	--scoreTxt.text = tostring(score)
	--totalscoreTxt.text = tostring(score - totaltime)
	
end


-- Called when scene is about to move offscreen:
function scene:exitScene( event )
	local group = self.view
	
	-----------------------------------------------------------------------------
	
	--	INSERT code here (e.g. stop timers, remove listeners, unload sounds, etc.)
	
	-----------------------------------------------------------------------------
	
end


-- Called prior to the removal of scene's "view" (display group)
function scene:destroyScene( event )
	local group = self.view
	
	-----------------------------------------------------------------------------
	
	--	INSERT code here (e.g. remove listeners, widgets, save state, etc.)
	
	-----------------------------------------------------------------------------
	
end


---------------------------------------------------------------------------------
-- END OF YOUR IMPLEMENTATION
---------------------------------------------------------------------------------

-- "createScene" event is dispatched if scene's view does not exist
scene:addEventListener( "createScene", scene )

-- "enterScene" event is dispatched whenever scene transition has finished
scene:addEventListener( "enterScene", scene )

-- "exitScene" event is dispatched before next scene's transition begins
scene:addEventListener( "exitScene", scene )

-- "destroyScene" event is dispatched before view is unloaded, which can be
-- automatically unloaded in low memory situations, or explicitly via a call to
-- storyboard.purgeScene() or storyboard.removeScene().
scene:addEventListener( "destroyScene", scene )

---------------------------------------------------------------------------------

return scene