----------------------------------------------------------------------------------
--
-- scenetemplate.lua
--
----------------------------------------------------------------------------------

local storyboard = require( "storyboard" )
local scene = storyboard.newScene()



--typeOfPlay
----------------------------------------------------------------------------------
-- 
--	NOTE:
--	
--	Code outside of listener functions (below) will only be executed once,
--	unless storyboard.removeScene() is called.
-- 
---------------------------------------------------------------------------------

--local sndNoMatch = audio.loadSound("audio/nomatch.mp3")
--local sndMatch = audio.loadSound("audio/match.mp3")
--local sndWinner = audio.loadSound("audio/winner.mp3")


local function gotoFinish()
    storyboard.purgeScene("play")
	storyboard.removeScene("play")
	
	storyboard.gotoScene( "selectstage",  {time=100, effect="fade"})
end

function killDrift(obj)
    --kaleitai otan deixno to drifting text kai teleionei
    display.remove(obj)
    obj = nil
end




---------------------------------------------------------------------------------
-- BEGINNING OF YOUR IMPLEMENTATION
---------------------------------------------------------------------------------

-- Called when the scene's view does not exist:
function scene:createScene( event )
	local group = self.view
	
	
	-----------------------------------------------------------------------------
		
	--	CREATE display objects and add them to 'group' here.
	--	Example use-case: Restore 'group' from previously saved state.
	
	-----------------------------------------------------------------------------

	local prior_scene = storyboard.getPrevious()
	storyboard.purgeScene( prior_scene )
	
	
	storyboard.purgeScene("play")
	storyboard.removeScene("play")
	
	
	 
end


-- Called immediately after scene has moved onscreen:
function scene:enterScene( event )
	local group = self.view
	-----------------------------------------------------------------------------
		
	--	INSERT code here (e.g. start timers, load audio, start listeners, etc.)
	
	-----------------------------------------------------------------------------
	
	--print("Enterd");
	
	
	local dTxtCongrats = display.newText("All levels complete !!",0,0,native.systemFontBold, 24)
    dTxtCongrats.x = display.contentCenterX
    dTxtCongrats.y = display.contentHeight+300
    
    local dTxtCompleted = display.newText("Thank you for playing !!",0,0,native.systemFontBold, 24)
    dTxtCompleted.x = display.contentCenterX
    dTxtCompleted.y = display.contentHeight+350
    
    group:insert(dTxtCongrats) 

    group:insert(dTxtCompleted) 


    transition.to(dTxtCongrats,{delay=0, time=30000, y =-display.contentHeight, alpha=0, onComplete=killDrift})
    transition.to(dTxtCompleted,{delay=0, time=30000, y =-display.contentHeight+50, alpha=0, onComplete=gotoFinish})
	 
	
end


-- Called when scene is about to move offscreen:
function scene:exitScene( event )
	local group = self.view
	
	-----------------------------------------------------------------------------
	
	--	INSERT code here (e.g. stop timers, remove listeners, unload sounds, etc.)
	
	-----------------------------------------------------------------------------
	
end


-- Called prior to the removal of scene's "view" (display group)
function scene:destroyScene( event )
	local group = self.view
	
	-----------------------------------------------------------------------------
	
	--	INSERT code here (e.g. remove listeners, widgets, save state, etc.)
	
	-----------------------------------------------------------------------------
	
end


---------------------------------------------------------------------------------
-- END OF YOUR IMPLEMENTATION
---------------------------------------------------------------------------------

-- "createScene" event is dispatched if scene's view does not exist
scene:addEventListener( "createScene", scene )

-- "enterScene" event is dispatched whenever scene transition has finished
scene:addEventListener( "enterScene", scene )

-- "exitScene" event is dispatched before next scene's transition begins
scene:addEventListener( "exitScene", scene )

-- "destroyScene" event is dispatched before view is unloaded, which can be
-- automatically unloaded in low memory situations, or explicitly via a call to
-- storyboard.purgeScene() or storyboard.removeScene().
scene:addEventListener( "destroyScene", scene )

---------------------------------------------------------------------------------

return scene