----------------------------------------------------------------------------------
--
-- scenetemplate.lua
--
----------------------------------------------------------------------------------

local storyboard = require( "storyboard" )
local scene = storyboard.newScene()

local sceneGroup

local widget = require("widget")
require "extras"

local group2


local ads = require "ads"

--typeOfPlay
----------------------------------------------------------------------------------
-- 
--	NOTE:
--	
--	Code outside of listener functions (below) will only be executed once,
--	unless storyboard.removeScene() is called.
-- 
---------------------------------------------------------------------------------

--local sndNoMatch = audio.loadSound("audio/nomatch.mp3")
--local sndMatch = audio.loadSound("audio/match.mp3")
--local sndWinner = audio.loadSound("audio/winner.mp3")

-- in a module where fullscreen ads are to be displayed
    local isSimulator = system.getInfo("environment") == "simulator"
    local function testNetworkConnection()
        local netConn = require('socket').connect('www.apple.com', 80)
        if netConn == nil then
            return false
        end
        netConn:close()
        return true
    end
	

local function changeMusic(e)
        local x
        local y
        x = btnSound.x
        y = btnSound.y
        btnSound:removeEventListener("tap",changeMusic)
        sceneGroup:remove(btnSound)

        if (withBackgroundMousic==true) then
            withBackgroundMousic = false
            btnSound = display.newImageRect(menuScreen.soundPlay, menuScreen.soundbuttonDimention, menuScreen.soundbuttonDimention)

            
            audio.stop()
        else 
            withBackgroundMousic = true
            btnSound = display.newImageRect(menuScreen.soundPause, menuScreen.soundbuttonDimention, menuScreen.soundbuttonDimention)
            
            playLoopSound( theme_sound,1, -1 , 0.3)

        end

        btnSound.x = x
        btnSound.y = y
        sceneGroup:insert(btnSound)
        btnSound:addEventListener("tap",changeMusic)
end

		
local function restartLevel(e)
   -- currentLevel = e.target.idx
    storyboard.purgeScene("play")
    storyboard.removeScene("play")
    storyboard.gotoScene( "play", {effect="fade"} )

end

local function nextLevel(e)
    currentLevel = currentLevel + 1
    currentStage = stageToGo
    storyboard.purgeScene("play")
    storyboard.removeScene("play")
    storyboard.gotoScene( "play", {effect="fade"} )

end


---------------------------------------------------------------------------------
-- BEGINNING OF YOUR IMPLEMENTATION
---------------------------------------------------------------------------------

-- Called when the scene's view does not exist:
function scene:createScene( event )
	local group = self.view
	sceneGroup = group

	local prior_scene = storyboard.getPrevious()
	storyboard.purgeScene( prior_scene )
	
	storyboard.purgeScene("play")
	storyboard.removeScene("play")


	loadPrefs()


	--local myStagesBackground = display.newImage( menuScreen.LevelSelect_Background)
    --local background = display.newImageRect( menuScreen.LevelSelect_Background, 380, 570 )
    --myStagesBackground.x = centerX-- display.contentWidth/2--display.contentCenterX
    --myStagesBackground.y = centerY --display.contentHeight/2--display.contentCenterY
    --sceneGroup:insert(myStagesBackground) 

	
	--SOUNDS
    if (withBackgroundMousic==true) then
        btnSound = display.newImageRect(menuScreen.soundPause, menuScreen.soundbuttonDimention, menuScreen.soundbuttonDimention)
    else 
        btnSound = display.newImageRect(menuScreen.soundPlay, menuScreen.soundbuttonDimention, menuScreen.soundbuttonDimention)
    end
    btnSound.x = menuScreen.soundBtnXDimention-- 40--centerX
    btnSound.y = menuScreen.soundBtnYDimention -- display.contentHeight - 50
    sceneGroup:insert(btnSound)
    --group:insert(btnSound)
    btnSound:addEventListener("tap",changeMusic)
    --SOUNDS


	local sign_background = display.newImageRect(menuScreen.stagesimagesbackground, 300, 300)
	sign_background.x = centerX
	sign_background.y = centerY
	sceneGroup:insert(sign_background)


	--Level
	local levelImage2 = display.newImageRect(menuScreen.level, 65, 26)--Text( "time: ", 40, 20, "PAETRI", 24 )
	levelImage2.x = sign_background.x - 40 -- screenWidth - 100
	levelImage2.y = sign_background.y - 60 -- screenTop + 20 -- 120
	sceneGroup:insert(levelImage2)

	local myLevel = display.newText( "", 50, 10, native.systemFont, 22 )
    myLevel.text = tostring(currentLevel)
    myLevel.x = sign_background.x + 40
    myLevel.y = sign_background.y - 60
    sceneGroup:insert(myLevel)

    --End level

	--SCORE
	local scoreImage2 = display.newImageRect(menuScreen.score, 60, 20)--Text( "time: ", 40, 20, "PAETRI", 24 )
	scoreImage2.x = levelImage2.x -- screenWidth - 100
	scoreImage2.y = sign_background.y - 20 -- screenTop + 20 -- 120
	sceneGroup:insert(scoreImage2)


    local myScore2 = display.newText( "", 50, 10, native.systemFont, 22 )
    myScore2.text = tostring(levelScores[currentLevel])
    myScore2.x = myLevel.x
    myScore2.y = scoreImage2.y
    sceneGroup:insert(myScore2)

	--END SCORE

	for j=1, 3 do
        local mystarimage = display.newImageRect("images/buttons/stargray.png", 30, 30)
        mystarimage.x = sign_background.x - 32 +  ((j-1)*35) - 5
        mystarimage.y = scoreImage2.y + 50-- - yDimention 
        sceneGroup:insert(mystarimage)
    end
    local x = levelStars[currentLevel]
    if x == nil then
    	x = 0
    end
	for j=1, x do
		local  mystarimage = display.newImageRect("images/buttons/star.png", 30, 30)
		mystarimage.x = sign_background.x - 32 +  ((j-1)*35) - 5
		mystarimage.y = scoreImage2.y + 50-- - yDimention 
		sceneGroup:insert(mystarimage)
    end


    --Buttons

    local btnRestart = display.newImageRect(menuScreen.restartButton, menuScreen.soundbuttonDimention, menuScreen.soundbuttonDimention)
	btnRestart.x = levelImage2.x - 2
    btnRestart.y = scoreImage2.y + menuScreen.soundbuttonDimention + 60
    sceneGroup:insert(btnRestart)
    btnRestart:addEventListener("tap",restartLevel)


	local btnNext = display.newImageRect(menuScreen.nextButton, menuScreen.soundbuttonDimention, menuScreen.soundbuttonDimention)
	btnNext.x = myLevel.x - 2
    btnNext.y = btnRestart.y
    sceneGroup:insert(btnNext)
    btnNext:addEventListener("tap",nextLevel)


	 
end


-- Called immediately after scene has moved onscreen:
function scene:enterScene( event )
	local group = self.view
	group2 = group
	-----------------------------------------------------------------------------
		
	--	INSERT code here (e.g. start timers, load audio, start listeners, etc.)
	
	-----------------------------------------------------------------------------
	
	--print("Enterd");
	--local showAds = math.random( 0, 1 )
	--if showAds == 0 then
		
	showAdd = true

	--[[
		if ( isSimulator or not testNetworkConnection() ) then
			print("on simulator or no network connection, and therefore, no fullscreen ads")
		else
				local function adListener( event )
					if event.isError then
						-- Failed to receive an ad.
					end
				end

				ads.init( "admob", "ca-app-pub-9562809720714816/6482571285", adListener )
				ads.show( "interstitial", { x=0, y=0 } )
		end
	]]
	--end 

	
end


-- Called when scene is about to move offscreen:
function scene:exitScene( event )
	local group = self.view
	
	-----------------------------------------------------------------------------
	
	--	INSERT code here (e.g. stop timers, remove listeners, unload sounds, etc.)
	
	-----------------------------------------------------------------------------
	
end


-- Called prior to the removal of scene's "view" (display group)
function scene:destroyScene( event )
	local group = self.view
	
	-----------------------------------------------------------------------------
	
	--	INSERT code here (e.g. remove listeners, widgets, save state, etc.)
	
	-----------------------------------------------------------------------------
	
end


---------------------------------------------------------------------------------
-- END OF YOUR IMPLEMENTATION
---------------------------------------------------------------------------------

-- "createScene" event is dispatched if scene's view does not exist
scene:addEventListener( "createScene", scene )

-- "enterScene" event is dispatched whenever scene transition has finished
scene:addEventListener( "enterScene", scene )

-- "exitScene" event is dispatched before next scene's transition begins
scene:addEventListener( "exitScene", scene )

-- "destroyScene" event is dispatched before view is unloaded, which can be
-- automatically unloaded in low memory situations, or explicitly via a call to
-- storyboard.purgeScene() or storyboard.removeScene().
scene:addEventListener( "destroyScene", scene )

---------------------------------------------------------------------------------

return scene