-----------------------------------------------------------------------------------------
--
-- main.lua
--
-----------------------------------------------------------------------------------------

local storyboard = require "storyboard"
local GGData = require("GGData")

local prefs = GGData:new("preferences")

require "extras"
--local ads = require "ads"

display.setStatusBar(display.HiddenStatusBar);

centerX = display.contentCenterX;
centerY = display.contentCenterY;

screenX = display.screenOriginX
screenY = display.screenOriginY
screenWidth = display.contentWidth --- screenX * 2
screenHeight = display.contentHeight --- screenY * 2
screenLeft = 0 --screenX
screenRight = display.contentWidth -- screenWidth -- screenX + screenWidth
screenTop = 25 -- screenY + 25
screenBottom = screenHeight -- screenY + screenHeight
display.contentWidth = screenWidth
display.contentHeight = screenHeight

display.cl = displayCenterLeftReferencePoint

typeOfPlay = "" --alphabet, flags, 
typeOfPlay1 = "cars"
typeOfPlay2 = "animals"
typeOfPlay3 = "cartoons"
typeOfPlay4 = "rest"

showAdd = false


levelLocked = {}
levelScores = {}
levelStars = {}
levelsTotalNumber = 90
currentLevel = 1
stagesLocked = {}
stagesTotalNumber = 6
currentStage = 1
stageToGo = 1
withBackgroundMousic = true



tilesdimention = 0


theme_sound = audio.loadStream(menuScreen.Soundtrack)




--background = display.newImage("images/black_background.png")
--background  = display.newImage("images/black_background.png", true)
--background.x = centerX
--background.y = centerY
--background:toBack()

	
function playSound(audioObj,chn)
	audio.play( audioObj, {channel=chn} )
end

function playLoopSound(audioObj,chn, loop, volume)
	audio.setVolume( volume )
	audio.play( audioObj, {channel=chn, loops=loop} )
end


function resetGame()
	-- set up the default scores and locked tables
	for x =1, levelsTotalNumber do
		levelLocked[x] = true
		levelScores[x] = 0
		levelStars[x] = 0
	end
	levelLocked[1] = false

	for y=1, stagesTotalNumber do
		stagesLocked[y] = true
	end
	stagesLocked[1] = false

	--savePrefs()
end

function loadPrefs()
	prefs:load()
	
	levelLocked = prefs.levelLocked or levelLocked
	levelLocked[1] = false --make sure first
	levelScores = prefs.levelScores or levelScores
	levelStars = prefs.levelStars or levelStars

	for x =1, levelsTotalNumber do
		if levelStars[x] == nil then
			levelStars[x] = 0
		end
		if levelScores[x] == nil then
			levelScores[x] = 0
		end
	end

	for y=1, stagesTotalNumber do
		stagesLocked = prefs.stagesLocked or stagesLocked
		if stagesLocked == nil then
			stagesLocked = true
		end
	end

end

function savePrefs()
	prefs.levelLocked = levelLocked
	prefs.levelScores = levelScores
	prefs.levelStars = levelStars
	prefs.stagesLocked = stagesLocked

	prefs:save()
end 

function enableAllLevels()
	-- set up the default scores and locked tables
	for x =1, levelsTotalNumber do
		levelLocked[x] = false
		levelScores[x] = 0
		levelStars[x] = 0
	end
	levelLocked[1] = false

	for y=1, stagesTotalNumber do
		stagesLocked[y] = false
	end
	stagesLocked[1] = false

	savePrefs()
end


--[[
local function adListener( event )
    if event.isError then
        -- Failed to receive an ad.
    end
end

ads.init( "admob", "a15104da82282c3", adListener )
ads.show( "interstitial", { x=0, y=0 } )
]]--

-- load scenetemplate.lua
--[[
function inneractiveAadListener( event )
    if event.isError then
        -- Failed to receive an ad.
    end
end




ads.init( "inneractive", "OirdoGroup_MatchTheTiles_Android", inneractiveAadListener )

ads.show( "fullscreen", { x=0, y=0, interval=60 } )
]]--
--ads.show( "banner", { x=centerX, y=220, interval=220 } )
--ads.show( "fullscreen" [, params] )

playLoopSound( theme_sound,1, -1 , 0.3)


resetGame()

--
--enableAllLevels()
--
loadPrefs()

	mybackground = display.newImage( menuScreen.LevelSelect_Background)
    --local background = display.newImageRect( menuScreen.LevelSelect_Background, 380, 570 )
    mybackground.x = centerX-- display.contentWidth/2--display.contentCenterX
    mybackground.y = centerY --display.contentHeight/2--display.contentCenterY
    mybackground.alpha = 0.6
    mybackground:toBack()

storyboard.gotoScene( "splash" )
--storyboard.gotoScene( "selecttypeofplay" )

-- Add any objects that should appear on all scenes below (e.g. tab bar, hud, etc.):