----------------------------------------------------------------------------------
--
-- scenetemplate.lua
--
----------------------------------------------------------------------------------

local storyboard = require( "storyboard" )
local scene = storyboard.newScene()

local GGData = require("GGData")

local prefs = GGData:new("preferences")

local ads = require "ads"

local isSimulator = system.getInfo("environment") == "simulator"
local function testNetworkConnection()
    local netConn = require('socket').connect('www.apple.com', 80)
    if netConn == nil then
        return false
    end
    netConn:close()
    return true
end


local group2
--local mainmenuImage
--local playagainImage
----------------------------------------------------------------------------------
-- 
--	NOTE:
--	
--	Code outside of listener functions (below) will only be executed once,
--	unless storyboard.removeScene() is called.
-- 
---------------------------------------------------------------------------------

--local sndNoMatch = audio.loadSound("sounds/fail-buzzer-04.mp3")
local sndMatch = audio.loadSound("sounds/correct.mp3")
local sndWinner = audio.loadSound("sounds/auto_horn_1972_toyota_three_short_blasts.mp3")

local tileImg = "images/stagesimages/woodblock" .. tostring(currentStage) .. ".png"

require "extras"

local timeImage2
local scoreImage2

local hiddenObjects = {}
						--"yellow", "gemblue", "heart", "android", "rock", "star", "dog", "key",
						--"yellow", "gemblue", "heart", "android", "rock", "star", "dog", "key"
						--}
						
local hiddenObjectsSounds = {}
						
local tileWidth
local tileHeight
local tilesAcross
local tilesDown
local tileSpacing
local topSpacing --= screenTop + tileHeight + tileSpacing
local leftSpacing --= screenLeft + tileWidth + tileSpacing

local numMatches = 0
local numObjShowing = 0
local flipped = {}
local pauseDelay = 800
local score = 0
local scoreTxt = nil

local totalTime = 0
local totalTimeTxt = nil
local timeIntervalForTime


local homeImage
local thing
local tile

local allTiles = {} --wooden tiles
local allThings = {} -- objects behind tiles

local resetGame

local tile_Sound 

local scoreImage1
local timeImage1
local str
local isTime


local visibleTimes = {} -- noumera pou ebala ta times
local visibleScores = {} -- noumera pou ebala ta times

local cartoonObjects = {
						"/cartoon/1",
						"/cartoon/2",
						"/cartoon/3",
						"/cartoon/4",
						"/cartoon/5",
						"/cartoon/6",
						"/cartoon/7",
						"/cartoon/8",
						"/cartoon/9",
						"/cartoon/10",
						"/cartoon/11",
						"/cartoon/12",
						"/cartoon/13",
						"/cartoon/14",
						"/cartoon/15",
						"/cartoon/16",
						"/cartoon/17",
						"/cartoon/18",
						"/cartoon/19",
						"/cartoon/20",
						"/cartoon/21",
						"/cartoon/22",
						"/cartoon/23",
						"/cartoon/24",
						"/cartoon/25",
						"/cartoon/26",
						"/cartoon/27",
						"/cartoon/28",
						"/cartoon/29",
						"/cartoon/30",
						"/cartoon/31",
						"/cartoon/32",
						"/cartoon/33",
						"/cartoon/34",
						"/cartoon/35",
						"/cartoon/36",
						"/cartoon/37",
						"/cartoon/38",
						"/cartoon/39",
						"/cartoon/40",

}
--[[						"/cartoon/41",
						"/cartoon/42",
						"/cartoon/43",
						"/cartoon/44",
						"/cartoon/45",
						"/cartoon/46",
						"/cartoon/47",
						"/cartoon/48",
						"/cartoon/49",
						"/cartoon/50",
						"/cartoon/51",
						"/cartoon/52",
						"/cartoon/53",
						"/cartoon/54",
						"/cartoon/55",
						"/cartoon/56",
						"/cartoon/57",
						"/cartoon/58",
						"/cartoon/59",
						"/cartoon/60",
						"/cartoon/61",
						"/cartoon/62",
						"/cartoon/63",
						"/cartoon/64",
						"/cartoon/65",
						"/cartoon/66",
						"/cartoon/67",
						"/cartoon/68",
						"/cartoon/69",
						"/cartoon/70",
						"/cartoon/71",
						"/cartoon/72"]]


local birdsObjects = {
						"/animals/1",
						"/animals/2",
						"/animals/3",
						"/animals/4",
						"/animals/5",
						"/animals/6",
						"/animals/7",
						"/animals/8",
						"/animals/9",
						"/animals/10",
						"/animals/11",
						"/animals/13",
						"/animals/14",
						"/animals/15",
						"/animals/16",
						"/animals/17",
						"/animals/18",
						"/animals/19",
						"/animals/20",
						"/animals/21",
						"/animals/22",
						"/animals/23",
						"/animals/24",
						"/animals/25",
						"/animals/26",
						"/animals/27",
						"/animals/28",
						"/animals/29",
						"/animals/30",
						"/animals/31",
						"/animals/32",
						"/animals/33",
						"/animals/34"
						}

local flagsObjects = {
						"/cars/1",
						"/cars/2",
						"/cars/3",
						"/cars/4",
						"/cars/5",
						"/cars/6",
						"/cars/7",
						"/cars/8",
						"/cars/9",
						"/cars/10",
						"/cars/11",
						"/cars/12",
						"/cars/13",
						"/cars/14",
						"/cars/15",
						"/cars/16",
						"/cars/17",
						"/cars/18",
						"/cars/19",
						"/cars/20",
						"/cars/21",
						"/cars/22",
						"/cars/23",
						"/cars/24",
						"/cars/25",
						"/cars/26",
						"/cars/27",
						"/cars/28",
						"/cars/29",
						"/cars/30",
						"/cars/31",
						"/cars/32",
						"/cars/33",
						"/cars/34",
						"/cars/35",
						"/cars/36",
						"/cars/37",
						"/cars/38",
						"/cars/39",
						"/cars/40"
						}

						
local restObjects = {
							"/restimages/1",
							"/restimages/2",
							"/restimages/3",
							"/restimages/4",
							"/restimages/5",
							"/restimages/6",
							"/restimages/7",
							"/restimages/8",
							"/restimages/9",
							"/restimages/10",
							"/restimages/11",
							"/restimages/12",
							"/restimages/13",
							"/restimages/14",
							"/restimages/15",
							"/restimages/16",
							"/restimages/17",
							"/restimages/18",
							"/restimages/19",
							"/restimages/20",
							"/restimages/21",
							"/restimages/22",
							"/restimages/23",
							"/restimages/24",
							"/restimages/25",
							"/restimages/26",
							"/restimages/27",
							"/restimages/28",
							"/restimages/29",
							"/restimages/30",
							"/restimages/31",
							"/restimages/32",
							"/restimages/33",
							"/restimages/34"
						}
				

local function savePrefs()
	prefs.levelLocked = levelLocked
	prefs.levelScores = levelScores
	prefs.levelStars = levelStars
	prefs.stagesLocked = stagesLocked

	prefs:save()
end 

function playSoundWithVolume(audioObj,volume)
	audio.setVolume( volume )
	audio.play( audioObj )
end

function round(what, precision)
   return math.floor(what*math.pow(10,precision)+0.5) / math.pow(10,precision)
end

local function resetVariables()

		print(" currentLevel  " .. tostring(currentLevel))
		if currentLevel < 4 then
			tilesdimention = 2
		elseif currentLevel < 15 then
			tilesdimention = 4
		elseif currentLevel < 45 then
			tilesdimention = 6
		elseif currentLevel < 80 then
			tilesdimention = 8
		elseif currentLevel > 80 then
			tilesdimention = 10
		end


	isTime = false
	
	timeIntervalForTime = 1000
	
	--print("tilesdimention: " .. tostring(tilesdimention))
	tileSpacing = 2
	--print("display.contentWidth: " .. display.contentWidth)
	--print("display.contentWidth/tilesdimention: " .. tostring(display.contentWidth/tilesdimention))
	
	local tilesWidth = (display.contentWidth)/ (tilesdimention +tileSpacing) -- (display.contentWidth - (2*tileSpacing))/ (tilesdimention + tileSpacing)
	--print("tilesWidth: " .. tostring(tilesWidth))
	
	tilesWidth = round(tilesWidth,0)
	--print("tilesWidth: " .. tostring(tilesWidth))
	tileWidth = tilesWidth
	--tileWidth = (display.contentWidth/tilesdimention) --- ((tileSpacing)*(tilesdimention))-- 62
	--print("tileWidth: " .. tostring(tileWidth))
	tileHeight = tileWidth --(display.contentHeight/tilesdimention - ((tileSpacing)*tilesdimention)) --62
	--print("tileHeight: " .. tostring(tileHeight))
	tilesAcross = tilesdimention
	tilesDown = tilesdimention
	
	topSpacing = 80--(display.contentHeight - (tileHeight*tilesdimention) + (2 * tileSpacing))/2 + screenTop -- screenTop + tileHeight + tileSpacing
	
	topSpacing =  (display.contentHeight - ((tileHeight + tileSpacing)*tilesdimention))/2
	--if (topSpacing > 60) then
	--	topSpacing  = 60
	--end
	
	
	leftSpacing = (tileWidth/2) + (display.contentWidth - (((tileWidth+tileSpacing)*tilesdimention)+ tileSpacing*2))/2 -- ((tileWidth + tileSpacing)*tilesdimention))/2--- (2*tileSpacing) -- screenLeft + 
	--print("display.contentWidth: " .. tostring(display.contentWidth))
	--print("leftSpacing: " .. tostring(leftSpacing))
	--print("(tileWidth+tileSpacing)*tilesdimention): " .. tostring((tileWidth+tileSpacing)*tilesdimention))
	
	leftSpacing = round(leftSpacing,0)
	--print("leftSpacing: " .. tostring(leftSpacing))
	
	--leftSpacing = (display.contentWidth - (tileWidth*tilesdimention))/2
	--print("leftSpacing: " .. tostring(leftSpacing))
	
	local myDimention = (tilesdimention*tilesdimention)/2
	--print("myDimention: " .. tostring(myDimention))
	for x=1, myDimention do
		--pare ena tixaio apo to index
		z = nil
		while z == nil do
		  z = math.random(1, 26)
		  
		end


		
		typeOfPlay = currentStage
		hiddenObjects[x] = cartoonObjects[z]
		hiddenObjects[myDimention+x] = cartoonObjects[z]

		--[[
		if typeOfPlay == 1 then
				hiddenObjects[x] = cartoonObjects[z]
				hiddenObjects[myDimention+x] = cartoonObjects[z]
				--print("hiddenObjects[x] " .. tostring(hiddenObjects[x]))
				--print("z: " .. tostring(z))
				--hiddenObjectsSounds[x] = cartoonObjectsSounds[z]
				--hiddenObjectsSounds[myDimention+x] = cartoonObjectsSounds[z]
		elseif typeOfPlay == 2 then
				hiddenObjects[x] = restObjects[z]
				hiddenObjects[myDimention+x] = restObjects[z]
		--elseif typeOfPlay == "animals" then
		--		hiddenObjects[x] = animalsObjects[z]
		--		hiddenObjects[myDimention+x] = animalsObjects[z]
		elseif typeOfPlay == 3 then
				hiddenObjects[x] = flagsObjects[z]
				hiddenObjects[myDimention+x] = flagsObjects[z]
		elseif typeOfPlay == 4 then
				hiddenObjects[x] = birdsObjects[z]
				hiddenObjects[myDimention+x] = birdsObjects[z]
				--rint("hiddenObjects[x] " .. tostring(hiddenObjects[x]))
		elseif typeOfPlay == 5 then
				hiddenObjects[x] = restObjects[z]
				hiddenObjects[myDimention+x] = restObjects[z]
		elseif typeOfPlay == 6 then
				hiddenObjects[x] = flagsObjects[z]
				hiddenObjects[myDimention+x] = flagsObjects[z]
		end
		]]
		
	end
	--[[
	hiddenObjects = {
						"/englishAlphabet/a", "/englishAlphabet/b", "/englishAlphabet/c", "/englishAlphabet/e", "/englishAlphabet/f", "/englishAlphabet/g", "/englishAlphabet/h", "/englishAlphabet/i",
						"/englishAlphabet/a", "/englishAlphabet/b", "/englishAlphabet/c", "/englishAlphabet/e", "/englishAlphabet/f", "/englishAlphabet/g", "/englishAlphabet/h", "/englishAlphabet/i",
						
						"/englishAlphabet/j", "/englishAlphabet/k", "/englishAlphabet/l", "/englishAlphabet/m", "/englishAlphabet/n", "/englishAlphabet/o", 
						"/englishAlphabet/j", "/englishAlphabet/k", "/englishAlphabet/l", "/englishAlphabet/m", "/englishAlphabet/n", "/englishAlphabet/o",
						
						"/englishAlphabet/p", "/englishAlphabet/q", "/englishAlphabet/r", "/englishAlphabet/s", "/englishAlphabet/t", "/englishAlphabet/u", 
						"/englishAlphabet/p", "/englishAlphabet/q", "/englishAlphabet/r", "/englishAlphabet/s", "/englishAlphabet/t", "/englishAlphabet/u", 
						
						"/englishAlphabet/v", "/englishAlphabet/w", "/englishAlphabet/x", "/englishAlphabet/y", "/englishAlphabet/z",
						"/englishAlphabet/v", "/englishAlphabet/w", "/englishAlphabet/x", "/englishAlphabet/y", "/englishAlphabet/z",
						
						"/englishAlphabet/a", "/englishAlphabet/b", "/englishAlphabet/c", "/englishAlphabet/e", "/englishAlphabet/f", "/englishAlphabet/g", "/englishAlphabet/h", "/englishAlphabet/i",
						"/englishAlphabet/a", "/englishAlphabet/b", "/englishAlphabet/c", "/englishAlphabet/e", "/englishAlphabet/f", "/englishAlphabet/g", "/englishAlphabet/h", "/englishAlphabet/i",
						
						"/englishAlphabet/j", "/englishAlphabet/k", "/englishAlphabet/l", "/englishAlphabet/m", "/englishAlphabet/n", "/englishAlphabet/o", 
						"/englishAlphabet/j", "/englishAlphabet/k", "/englishAlphabet/l", "/englishAlphabet/m", "/englishAlphabet/n", "/englishAlphabet/o",
						
						"/englishAlphabet/p", "/englishAlphabet/q", "/englishAlphabet/r", "/englishAlphabet/s", "/englishAlphabet/t", "/englishAlphabet/u", 
						"/englishAlphabet/p", "/englishAlphabet/q", "/englishAlphabet/r", "/englishAlphabet/s", "/englishAlphabet/t", "/englishAlphabet/u", 
						
						"/englishAlphabet/v", "/englishAlphabet/w", "/englishAlphabet/x", "/englishAlphabet/y", "/englishAlphabet/z",
						"/englishAlphabet/v", "/englishAlphabet/w", "/englishAlphabet/x", "/englishAlphabet/y", "/englishAlphabet/z"
						}
	hiddenObjectsSounds = {
						"/sounds/englishAlphabet/a.mp3", "/sounds/englishAlphabet/b.mp3", "/sounds/englishAlphabet/c.mp3", "/sounds/englishAlphabet/e.mp3", "/sounds/englishAlphabet/f.mp3", "/sounds/englishAlphabet/g.mp3", "/sounds/englishAlphabet/h.mp3", "/sounds/englishAlphabet/i.mp3",
						"/sounds/englishAlphabet/a.mp3", "/sounds/englishAlphabet/b.mp3", "/sounds/englishAlphabet/c.mp3", "/sounds/englishAlphabet/e.mp3", "/sounds/englishAlphabet/f.mp3", "/sounds/englishAlphabet/g.mp3", "/sounds/englishAlphabet/h.mp3", "/sounds/englishAlphabet/i.mp3",
						
						"/sounds/englishAlphabet/j.mp3", "/sounds/englishAlphabet/k.mp3", "/sounds/englishAlphabet/l.mp3", "/sounds/englishAlphabet/m.mp3", "/sounds/englishAlphabet/n.mp3", "/sounds/englishAlphabet/o.mp3", 
						"/sounds/englishAlphabet/j.mp3", "/sounds/englishAlphabet/k.mp3", "/sounds/englishAlphabet/l.mp3", "/sounds/englishAlphabet/m.mp3", "/sounds/englishAlphabet/n.mp3", "/sounds/englishAlphabet/o.mp3",
						
						"/sounds/englishAlphabet/p.mp3", "/sounds/englishAlphabet/q.mp3", "/sounds/englishAlphabet/r.mp3", "/sounds/englishAlphabet/s.mp3", "/sounds/englishAlphabet/t.mp3", "/sounds/englishAlphabet/u.mp3", 
						"/sounds/englishAlphabet/p.mp3", "/sounds/englishAlphabet/q.mp3", "/sounds/englishAlphabet/r.mp3", "/sounds/englishAlphabet/s.mp3", "/sounds/englishAlphabet/t.mp3", "/sounds/englishAlphabet/u.mp3", 
						
						"/sounds/englishAlphabet/v.mp3", "/sounds/englishAlphabet/w.mp3", "/sounds/englishAlphabet/x.mp3", "/sounds/englishAlphabet/y.mp3", "/sounds/englishAlphabet/z.mp3",
						"/sounds/englishAlphabet/v.mp3", "/sounds/englishAlphabet/w.mp3", "/sounds/englishAlphabet/x.mp3", "/sounds/englishAlphabet/y.mp3", "/sounds/englishAlphabet/z.mp3",
						
						"/sounds/englishAlphabet/a.mp3", "/sounds/englishAlphabet/b.mp3", "/sounds/englishAlphabet/c.mp3", "/sounds/englishAlphabet/e.mp3", "/sounds/englishAlphabet/f.mp3", "/sounds/englishAlphabet/g.mp3", "/sounds/englishAlphabet/h.mp3", "/sounds/englishAlphabet/i.mp3",
						"/sounds/englishAlphabet/a.mp3", "/sounds/englishAlphabet/b.mp3", "/sounds/englishAlphabet/c.mp3", "/sounds/englishAlphabet/e.mp3", "/sounds/englishAlphabet/f.mp3", "/sounds/englishAlphabet/g.mp3", "/sounds/englishAlphabet/h.mp3", "/sounds/englishAlphabet/i.mp3",
						
						"/sounds/englishAlphabet/j.mp3", "/sounds/englishAlphabet/k.mp3", "/sounds/englishAlphabet/l.mp3", "/sounds/englishAlphabet/m.mp3", "/sounds/englishAlphabet/n.mp3", "/sounds/englishAlphabet/o.mp3", 
						"/sounds/englishAlphabet/j.mp3", "/sounds/englishAlphabet/k.mp3", "/sounds/englishAlphabet/l.mp3", "/sounds/englishAlphabet/m.mp3", "/sounds/englishAlphabet/n.mp3", "/sounds/englishAlphabet/o.mp3",
						
						"/sounds/englishAlphabet/p.mp3", "/sounds/englishAlphabet/q.mp3", "/sounds/englishAlphabet/r.mp3", "/sounds/englishAlphabet/s.mp3", "/sounds/englishAlphabet/t.mp3", "/sounds/englishAlphabet/u.mp3", 
						"/sounds/englishAlphabet/p.mp3", "/sounds/englishAlphabet/q.mp3", "/sounds/englishAlphabet/r.mp3", "/sounds/englishAlphabet/s.mp3", "/sounds/englishAlphabet/t.mp3", "/sounds/englishAlphabet/u.mp3", 
						
						"/sounds/englishAlphabet/v.mp3", "/sounds/englishAlphabet/w.mp3", "/sounds/englishAlphabet/x.mp3", "/sounds/englishAlphabet/y.mp3", "/sounds/englishAlphabet/z.mp3",
						"/sounds/englishAlphabet/v.mp3", "/sounds/englishAlphabet/w.mp3", "/sounds/englishAlphabet/x.mp3", "/sounds/englishAlphabet/y.mp3", "/sounds/englishAlphabet/z.mp3"
						}
	hiddenObjects = {
						"yellow", "gemblue", "heart", "android", "rock", "star", "dog", "key",
						"yellow", "gemblue", "heart", "android", "rock", "star", "dog", "key",
						
						"plant", "clock", "ladder", "gun11", "exit", "lifejacket", 
						"plant", "clock", "ladder", "gun11", "exit", "lifejacket"
						}
						]]--
end 


local function setImage()
	local j
	--print("isTime: " .. isTime)
	if isTime == true then	
	
		for j=1, #visibleTimes do
			--print("#visibleTimes[j]: " .. visibleTimes[j])
			if visibleTimes[j] ~= nil then
				--print("visibleTimes[i]: " .. visibleTimes[j])
				group2:remove(visibleTimes[j])
				visibleTimes[j] = nil
			end
			
		end
	else
		
		for j=1, #visibleScores do
			--print("#visibleTimes[j]: " .. visibleTimes[j])
			if visibleScores[j] ~= nil then
				--print("visibleTimes[i]: " .. visibleTimes[j])
				group2:remove(visibleScores[j])
				visibleScores[j] = nil
			end
			
		end
	end
			
	for i = 1, #str do
		
		local currentX
		
		local c = str:sub(i,i)
		-- do something with c
		print("c: " .. tostring(c))
		
			
			
			if c == "1" then
				myScoreImage = display.newImageRect("images/newimages/" .. c .. ".png", 10, 20)
				currentX = 12
			elseif (c == "2") or (c == "6") or (c == "7") or (c == "8") or (c == "9") or (c == "0") then	
				myScoreImage = display.newImageRect("images/newimages/" .. c .. ".png", 13, 20)
				currentX = 15
			elseif (c == "3") or (c == "5") then	
				myScoreImage = display.newImageRect("images/newimages/" .. c .. ".png", 14, 20)
				currentX = 16
			elseif (c == "4") then
				myScoreImage = display.newImageRect("images/newimages/" .. c .. ".png", 15, 20)
				currentX = 17
			end
			
			if i == 1 then
				previousX = xDimen
			else
				--previousX = previousX
			end
			print("i: " .. tostring(i))
			print("previousX: " .. tostring(previousX))
			print("currentX: " .. tostring(currentX))
			
			myScoreImage.x = previousX + currentX
			
			previousX = previousX + currentX
			
			myScoreImage.y = yDimen
			group2:insert(myScoreImage)
			
			if isTime == true then
				visibleTimes[i] = myScoreImage
			else
				visibleScores[i] = myScoreImage
			end
			--visibleTimes
			print("myScoreImage.x: " .. tostring(myScoreImage.x))
			print("myScoreImage.y: " .. tostring(myScoreImage.y))
	end
end


local function shuffle(t)
	local n = #t
	while n>2 do
		local k = math.random(n)
		t[n], t[k] = t[k], t[n]
		n = n -1
	end
	return t
end

local function killObj(obj)
	display.remove(obj)
	obj = nil
end

function startOver()
	local msg
	local function start(event)
		--killObj(event.target)
		resetGame()
	end
	resetGame()
	--[[
	msg = display.newText("tap to start game", 0, 0, "Helvetica", 24)
	msg.x = centerX
	msg.y = centerY + 100
	msg:addEventListener("tap", start)
	]]--
end

local function addToScore(addNum)
	local num = addNum or 100
	score = score + num
	--scoreTxt.text = "Score: " .. score
	
	str = tostring(score)
	--xDimen = scoreImage.x + scoreImage.width/2
	--yDimen = scoreImage.y
	scoreImage1.text = str -- "score: " .. 
	scoreImage1.x = scoreImage2.x + scoreImage2.width/2 + string.len(score) * 8

	--setImage()
	
	--scoreTxt:setReferencePoint(display.cl)
	--scoreTxt.x = screenWidth - 120
	
	--scoreTxt.x = screenWidth - 30
	--scoreTxt.y = screenTop + 25
end

local function resetNumObjsShowing()

end


local function processTime()
	--auksano to xrono
	totalTime = totalTime + 1--timeIntervalForTime
	
	--totalTimeTxt.text = "Time: " .. tostring(totalTime)
	
	str = tostring(totalTime)
	isTime = true
	--xDimen = timeImage.x + timeImage.width/2
	--yDimen = timeImage.y
	timeImage1.text = str --"time: " .. 
	timeImage1.x = timeImage2.x + timeImage2.width/2 + string.len(str) * 8  --17
	--setImage()
	isTime = false
	
	
end

local function checkForMatch()
	
	--print("print")
	if #flipped == 2 then
		local idx1, idx2 = flipped[1], flipped[2]
		local function resetNumObjsShowing()
			numObjShowing = 0
		end
		--print("idx1: " .. idx1)
		--print("idx2: " .. idx2)
		--print("allThings[idx1] " .. allThings[idx1].name)
		--print("allThings[idx2] " .. allThings[idx2].name)
		if allThings[idx1].name ==  allThings[idx2].name then
			--match
			audio.play(sndMatch)

			allThings[idx1]:toFront()
			allThings[idx2]:toFront()
			transition.to(allThings[idx1], {time=400, x=screenRight, y=screenTop, alpha=0})
			transition.to(allThings[idx2], {time=400, x=screenRight, y=screenTop, alpha=0})
			addToScore(100)


			--play sound

			--


			resetNumObjsShowing()
			numMatches = numMatches + 1
			
			--print("numMatches " .. numMatches)
			--print ("(tilesAcross + tilesDown) /2 " .. (tilesAcross * tilesDown) /2)
			
			if numMatches == ((tilesAcross * tilesDown) /2) then
				playSoundWithVolume(sndWinner,0.2)
				--audio.play(sndWinner)
				--startOver()
				--finished()
				
				--edo 8a bgalo merikes fores tin diafimisi
				
					--kerdise ara edo kano oti prepei na kano 
					--px na ftiakso score
					--na balo asteria k.l.p.
					if currentLevel+1 < levelsTotalNumber then 
						loadPrefs()


						local myScore = 0 
						score = score - totalTime
						if score > 0 then 
							myScore = score
						else 
							myScore = 50
						end
						levelScores[currentLevel] = myScore

						if myScore > 200 then
							levelStars[currentLevel] = 3
						elseif myScore > 100 then
							levelStars[currentLevel] = 2
						else
							levelStars[currentLevel] = 1
						end					
						levelLocked[currentLevel + 1] = false

						if (currentLevel + 1) > 75 then
							stagesLocked[6] = false
							stageToGo = 6
						elseif (currentLevel + 1) > 60 then
							stagesLocked[5] = false
							stageToGo = 5
						elseif (currentLevel + 1) > 45 then
							stagesLocked[4] = false
							stageToGo = 4
						elseif (currentLevel + 1) > 30 then
							stagesLocked[3] = false
							stageToGo = 3
						elseif (currentLevel + 1) > 15 then
							stagesLocked[2] = false
							stageToGo = 2
						else
							stageToGo = 1
						end

						savePrefs()
						storyboard.gotoScene( "gotonextscreen", {effect = "fade",time = 1000, params={totalTime = totalTime, score=score}})
					else
						loadPrefs()
						local myScore = 0 
						score = score - totalTime
						if score > 0 then 
							myScore = score
						else 
							myScore = 50
						end
						levelScores[currentLevel] = myScore
						if myScore > 200 then
							levelStars[currentLevel] = 3
						elseif myScore > 100 then
							levelStars[currentLevel] = 2
						else
							levelStars[currentLevel] = 1
						end					
						savePrefs()
						storyboard.gotoScene( "endscreen", {effect = "fade",time = 1000, params={totalTime = totalTime, score=score}})
					end
				
			end
		else
			--no match
			--audio.play(sndNomatch)
			transition.to(allTiles[idx1], {delay=pauseDelay, time=200, alpha=1, onComplete=resetNumObjsShowing})
			transition.to(allTiles[idx2], {delay=pauseDelay, time=200, alpha=1, onComplete=resetNumObjsShowing})
			if score > 20 then
				addToScore(-20)
			end
		end
		flipped[1] = nil
		flipped[2] = nil
	end
end

local function tileTapped(event)
	--tsekaro an exoume 2 tiled open
	--print("YES")
	--print(numObjShowing)
	if numObjShowing < 2 then
		local tile = event.target
		--print(flipped[numObjShowing])
		--print(tile.idx)
		
		if flipped[numObjShowing] ~= tile.idx then
		
			--settas
			print("allThings[tile.idx].kind: " .. allThings[tile.idx].kind)
			
			--end settas
			numObjShowing = numObjShowing + 1
			flipped[numObjShowing] = tile.idx
			--print("inside")
			transition.to(tile, {time=300, alpha=0, onComplete=checkForMatch})
		end
	end 
end

local function makeTiles(things)
	--things: the shuffled table
	local idx = 1
	
	allThings = {}
	allTiles = {}
	
	for x=1, tilesAcross do
		for y =1, tilesDown do
		
			--local firstTilex = screenWidth --centerX - (((tileWidth + tileSpacing) + leftSpacing) * ((tilesAcross/2)-1)) + leftSpacing
		
			--local thing = display.newImageRect("images/" .. things[idx] .. ".png",tileWidth,tileHeight)
			
			--thing.x = tilex + (x-1)*(tileWidth + tileSpacing) + leftSpacing
			
			print("idx: " .. idx)
			print("things[idx]: " .. tostring(things[idx]))
			
			
			print("tileWidth: " .. tostring(tileWidth))
			print("tileHeight: " .. tostring(tileHeight))
			
			thing = display.newImageRect("images" .. things[idx] .. ".png",tileWidth-2,tileHeight-2)
			
			print("thing: " .. "images" .. things[idx] .. ".png")
			if x==1 then
				thing.x = (x-1)*(tileWidth + tileSpacing) + leftSpacing-- + tileSpacing
				print("thing.x: " .. thing.x)
			else
				thing.x = (x-1)*(tileWidth + tileSpacing) + leftSpacing
				print("thing.x: " .. thing.x)
			end
			--[[
			if (x==1 or x==tilesAcross) then
				print("thing.x: " .. thing.x)
			end 
			]]--
			thing.y = (y-1)*(tileHeight + tileSpacing) + topSpacing + 10
			thing.name = things[idx]
			--print(thing.name)
			--print("idx: " .. tostring(idx))
			--print(hiddenObjectsSounds[idx])
			thing.kind = "/sounds" .. things[idx] .. ".mp3" --hiddenObjectsSounds[idx]
			--print("thing.kind: " .. thing.kind)
			--print(thing.name)
			--print("#allThings " .. #allThings)
			allThings[#allThings+1] = thing		
			--print("allThings[#allThings] " .. allThings[#allThings])
			--print("allThings[#allThings+1].name " .. allThings[#allThings].name)
			
			group2:insert(thing)
			
			tile = display.newImageRect(tileImg,tileWidth,tileHeight)


			
			tile.x = (x-1)*(tileWidth + tileSpacing) + leftSpacing
			tile.y = (y-1)*(tileHeight + tileSpacing) + topSpacing + 10
			tile.idx = idx
			tile:addEventListener("tap", tileTapped)


			allTiles[#allTiles+1] = tile	
			
			idx = idx + 1
			group2:insert(tile)

		end
	end
end


local function gotoHome()
	storyboard.gotoScene( "selectstage", {time=100, effect="fade"} )
	--storyboard.gotoScene( "selectdimention", {time=100, effect="flipFadeOutIn"} )
	
end



function resetGame()
	numMatches = 0
	numObjsShowing = 0
	score = 0
	--scoreTxt.text = "Score: 000"
	flipped[1] = nil
	flipped[2] = nil
	
	if allThings ~= {} then
		for x = #allThings, 1, -1 do
			killObj(allThings[x])
		end
		allThings = {}
	end
	
	if allTiles ~= {} then
		for x = #allTiles, 1, -1 do
			killObj(allTiles[x])
		end
		alltiles = {}
	end
	
	makeTiles(shuffle(hiddenObjects))
end


--[[
local objs = shuffle(hiddenObjects)
for key, value in pairs(objs) do
	print(key, value)
end
]]--
---------------------------------------------------------------------------------
-- BEGINNING OF YOUR IMPLEMENTATION
---------------------------------------------------------------------------------

-- Called when the scene's view does not exist:
function scene:createScene( event )
	local group = self.view

	
	group2 = group
	
	local prior_scene = storyboard.getPrevious()
	storyboard.purgeScene( prior_scene )
	
	
	storyboard.purgeScene("endplay")
	storyboard.removeScene("endplay")
	
	-----------------------------------------------------------------------------
		
	--	CREATE display objects and add them to 'group' here.
	--	Example use-case: Restore 'group' from previously saved state.
	
	-----------------------------------------------------------------------------
	--background.toBack()

	--local background = display.newImage( menuScreen.LevelSelect_Background)
    --local background = display.newImageRect( menuScreen.LevelSelect_Background, 380, 570 )
    --background.x = centerX-- display.contentWidth/2--display.contentCenterX
    --background.y = centerY --display.contentHeight/2--display.contentCenterY
    --group2:insert(background) 

	
	resetVariables()
	
	
	
	
	
	--edo to home
	homeImage = display.newImageRect(menuScreen.backbutton, menuScreen.soundbuttonDimention*(3/4), menuScreen.soundbuttonDimention*(3/4))
  	homeImage.x = menuScreen.soundbuttonDimention
    homeImage.y =  menuScreen.soundbuttonDimention
    homeImage:addEventListener( "tap", gotoHome )
    group:insert(homeImage)


    --LEVEL
	local levelImage = display.newImageRect(menuScreen.level, 62, 30)
	levelImage.x = centerX - 20
	levelImage.y = screenTop + 20 --scoreImage2.y + 40
	group:insert(levelImage)

	--timeImage
	local levelImage1 = display.newText( "", 40, 20, native.systemFont, 23 )
	levelImage1.x = levelImage.x + levelImage.width/2 + string.len(currentLevel) * 8
	levelImage1.y = levelImage.y - 2-- 120
	levelImage1.text = tostring(currentLevel)
	group:insert(levelImage1)

	--Score kato deksia
	score = 0
	
	scoreImage2 = display.newImageRect(menuScreen.score, 60, 20)--Text( "time: ", 40, 20, "PAETRI", 24 )
	scoreImage2.x = screenWidth - 100
	scoreImage2.y = screenBottom - 50 -- screenTop + 20 -- 120
	group:insert(scoreImage2)

	
	scoreImage1 = display.newText( "", 40, 20, native.systemFont, 20 )
	scoreImage1.x = scoreImage2.x + scoreImage2.width/2 + string.len("0") * 8 -- screenWidth - 100
	scoreImage1.y = scoreImage2.y + 2--screenBottom - 50 -- screenTop + 20 -- 120
	group:insert(scoreImage1)

	
	scoreImage1.text = scoreImage1.text .. "0"

	--Time  kato aristera
	totalTime = 0
	
	timeImage2 = display.newImageRect(menuScreen.time, 55, 20)--Text( "time: ", 40, 20, "PAETRI", 24 )
	timeImage2.x = menuScreen.soundbuttonDimention
	timeImage2.y = screenBottom - 50 -- 120
	group:insert(timeImage2)

	--timeImage
	timeImage1 = display.newText( "", 40, 20, native.systemFont, 19 )
	timeImage1.x = timeImage2.x + timeImage2.width/2 + string.len("0") * 8
	timeImage1.y = timeImage2.y + 2-- 120
	group:insert(timeImage1)
	
	str = tostring(totalTime)
	isTime = true

	timeImage1.text = timeImage1.text .. str

	--setImage()
	isTime = false

	timerIntervalForTime = timer.performWithDelay( timeIntervalForTime, processTime, 0 )
	

	
	
	startOver()
	
end


-- Called immediately after scene has moved onscreen:
function scene:enterScene( event )
	local group = self.view
	
	-----------------------------------------------------------------------------
		
	--	INSERT code here (e.g. start timers, load audio, start listeners, etc.)
	
	-----------------------------------------------------------------------------
	
	--print("Enterd");
	if showAdd == true then
		if ( isSimulator or not testNetworkConnection() ) then
			print("on simulator or no network connection, and therefore, no fullscreen ads")
		else
				local function adListener( event )
					if event.isError then
						-- Failed to receive an ad.
					end
				end

				ads.init( "admob", "ca-app-pub-9562809720714816/7018383285", adListener )
				ads.show( "interstitial", { x=0, y=0 } )
		end
		showAdd = false	
	end

	
end


-- Called when scene is about to move offscreen:
function scene:exitScene( event )
	local group = self.view
	
	-----------------------------------------------------------------------------
	
	--	INSERT code here (e.g. stop timers, remove listeners, unload sounds, etc.)
	
	-----------------------------------------------------------------------------
	
	flipped = {}
	allTiles = {} --wooden tiles
	allThings = {} -- objects behind tiles
	numMatches = 0
	numObjShowing = 0
	flipped = {}
	visibleTimes = {}
	visibleScores = {}

	timer.cancel(timerIntervalForTime)
end


-- Called prior to the removal of scene's "view" (display group)
function scene:destroyScene( event )
	local group = self.view
	
	-----------------------------------------------------------------------------
	
	--	INSERT code here (e.g. remove listeners, widgets, save state, etc.)
	
	-----------------------------------------------------------------------------
	
	
end


---------------------------------------------------------------------------------
-- END OF YOUR IMPLEMENTATION
---------------------------------------------------------------------------------

-- "createScene" event is dispatched if scene's view does not exist
scene:addEventListener( "createScene", scene )

-- "enterScene" event is dispatched whenever scene transition has finished
scene:addEventListener( "enterScene", scene )

-- "exitScene" event is dispatched before next scene's transition begins
scene:addEventListener( "exitScene", scene )

-- "destroyScene" event is dispatched before view is unloaded, which can be
-- automatically unloaded in low memory situations, or explicitly via a call to
-- storyboard.purgeScene() or storyboard.removeScene().
scene:addEventListener( "destroyScene", scene )

---------------------------------------------------------------------------------

return scene