----------------------------------------------------------------------------------
--
-- scenetemplate.lua
--
----------------------------------------------------------------------------------

local storyboard = require( "storyboard" )
local scene = storyboard.newScene()

local widget = require("widget")

--typeOfPlay
----------------------------------------------------------------------------------
-- 
--	NOTE:
--	
--	Code outside of listener functions (below) will only be executed once,
--	unless storyboard.removeScene() is called.
-- 
---------------------------------------------------------------------------------

--local sndNoMatch = audio.loadSound("audio/nomatch.mp3")
--local sndMatch = audio.loadSound("audio/match.mp3")
--local sndWinner = audio.loadSound("audio/winner.mp3")


local function gotoplay()
	--storyboard.hideOverlay("fromTop")
	--typeOfPlay = typeOfPlay2
	
	storyboard.purgeScene("play")
	storyboard.removeScene("play")
	
	storyboard.gotoScene( "play", {effect="flipFadeOutIn"} )
end

local function go2x2(e)
	tilesdimention = 2
	gotoplay()
end

local function go4x4(e)
	tilesdimention = 4
	gotoplay()
end

local function go6x6(e)
	tilesdimention = 6
	gotoplay()
end

local function go8x8(e)
	tilesdimention = 8
	gotoplay()
end

local function go10x10(e)
	tilesdimention = 10
	gotoplay()
end

local function killObj(obj)
	display.remove(obj)
	obj = nil
end

---------------------------------------------------------------------------------
-- BEGINNING OF YOUR IMPLEMENTATION
---------------------------------------------------------------------------------

-- Called when the scene's view does not exist:
function scene:createScene( event )
	local group = self.view

	
	local prior_scene = storyboard.getPrevious()
	storyboard.purgeScene( prior_scene )
	
	storyboard.purgeScene("play")
	storyboard.removeScene("play")
	
	
	-----------------------------------------------------------------------------
		
	--	CREATE display objects and add them to 'group' here.
	--	Example use-case: Restore 'group' from previously saved state.
	
	-----------------------------------------------------------------------------

	--local bLabel = "2x2 (4 tiles)"
	--local tapBtn = widget.newButton{label = bLabel, style = bStyle, onRelease=go2x2}
	local label1 = display.newImageRect("images/label.png", 256, 86)
	label1.x = centerX--display.contentWidth
	label1.y = 40--display.contentHeight + 300
	group:insert(label1)

	local x2Image = display.newText( "2x2 (4 tiles)", 40, 20, "PAETRI", 24 )
	x2Image.x = label1.x
	x2Image.y = label1.y
	label1:addEventListener( "tap", go2x2 )
	group:insert(x2Image)
	
	--local bLabel2 = "4x4 (16 tiles)"
	--local tapBtn2 = widget.newButton{label = bLabel2, style = bStyle, onRelease=go4x4}
	local label2 = display.newImageRect("images/label.png", 256, 86)
	label2.x = centerX--display.contentWidth
	label2.y = 140--display.contentHeight + 300
	group:insert(label2)

	local x4Image = display.newText( "4x4 (16 tiles)", 40, 20, "PAETRI", 24 )
	x4Image.x = label2.x
	x4Image.y = label2.y
	label2:addEventListener( "tap", go4x4 )
	group:insert(x4Image)
	
	--local bLabel3 = "6x6 (36 tiles)"
	--local tapBtn3 = widget.newButton{label = bLabel3, style = bStyle, onRelease=go6x6}
	local label3 = display.newImageRect("images/label.png", 256, 86)
	label3.x = centerX--display.contentWidth
	label3.y = 240--display.contentHeight + 300
	group:insert(label3)

	local x6Image = display.newText( "6x6 (36 tiles)", 40, 20, "PAETRI", 24 )
	x6Image.x = label3.x
	x6Image.y = label3.y
	label3:addEventListener( "tap", go6x6 )
	group:insert(x6Image)
	
	--local bLabel4 = "8x8 (64 tiles)"
	--local tapBtn4 = widget.newButton{label = bLabel4, style = bStyle, onRelease=go8x8}
	local label4 = display.newImageRect("images/label.png", 256, 86)
	label4.x = centerX--display.contentWidth
	label4.y = 340--display.contentHeight + 300
	group:insert(label4)

	local x8Image = display.newText( "8x8 (64 tiles)", 40, 20, "PAETRI", 24 )
	x8Image.x = label4.x
	x8Image.y = label4.y
	label4:addEventListener( "tap", go8x8 )
	group:insert(x8Image)
	
	--local bLabel5 = "10x10 (100 tiles)"
	--local tapBtn5 = widget.newButton{label = bLabel5, style = bStyle, onRelease=go10x10}
	local label5 = display.newImageRect("images/label.png", 256, 86)
	label5.x = centerX--display.contentWidth
	label5.y = 440--display.contentHeight + 300
	group:insert(label5)

	local x10Image = display.newText( "10x10 (100 tiles)", 40, 20, "PAETRI", 24 )
	x10Image.x = label5.x
	x10Image.y = label5.y
	label5:addEventListener( "tap", go10x10 )
	group:insert(x10Image)
end


-- Called immediately after scene has moved onscreen:
function scene:enterScene( event )
	local group = self.view
	
	-----------------------------------------------------------------------------
		
	--	INSERT code here (e.g. start timers, load audio, start listeners, etc.)
	
	-----------------------------------------------------------------------------
	
	--print("Enterd");
end


-- Called when scene is about to move offscreen:
function scene:exitScene( event )
	local group = self.view
	
	-----------------------------------------------------------------------------
	
	--	INSERT code here (e.g. stop timers, remove listeners, unload sounds, etc.)
	
	-----------------------------------------------------------------------------
	
end


-- Called prior to the removal of scene's "view" (display group)
function scene:destroyScene( event )
	local group = self.view
	
	-----------------------------------------------------------------------------
	
	--	INSERT code here (e.g. remove listeners, widgets, save state, etc.)
	
	-----------------------------------------------------------------------------
	
end


---------------------------------------------------------------------------------
-- END OF YOUR IMPLEMENTATION
---------------------------------------------------------------------------------

-- "createScene" event is dispatched if scene's view does not exist
scene:addEventListener( "createScene", scene )

-- "enterScene" event is dispatched whenever scene transition has finished
scene:addEventListener( "enterScene", scene )

-- "exitScene" event is dispatched before next scene's transition begins
scene:addEventListener( "exitScene", scene )

-- "destroyScene" event is dispatched before view is unloaded, which can be
-- automatically unloaded in low memory situations, or explicitly via a call to
-- storyboard.purgeScene() or storyboard.removeScene().
scene:addEventListener( "destroyScene", scene )

---------------------------------------------------------------------------------

return scene