----------------------------------------------------------------------------------
--
-- scenetemplate.lua
--
----------------------------------------------------------------------------------

local storyboard = require( "storyboard" )
local scene = storyboard.newScene()
local GGData = require("GGData")

local prefs = GGData:new("preferences")
local widget = require("widget")

local sceneGroup

require "extras"



--typeOfPlay
----------------------------------------------------------------------------------
-- 
--	NOTE:
--	
--	Code outside of listener functions (below) will only be executed once,
--	unless storyboard.removeScene() is called.
-- 
---------------------------------------------------------------------------------

--local sndNoMatch = audio.loadSound("audio/nomatch.mp3")
--local sndMatch = audio.loadSound("audio/match.mp3")
--local sndWinner = audio.loadSound("audio/winner.mp3")

local function loadPrefs()
    prefs:load()
    
    levelLocked = prefs.levelLocked or levelLocked
    levelLocked[1] = false --make sure first
    levelScores = prefs.levelScores or levelScores
    levelStars = prefs.levelStars or levelStars

    for x =1, levelsTotalNumber do
        if levelStars[x] == nil then
            levelStars[x] = 0
        end
        if levelScores[x] == nil then
            levelScores[x] = 0
        end
    end

    for y=1, stagesTotalNumber do
        stagesLocked = prefs.stagesLocked or stagesLocked
        if stagesLocked == nil then
            stagesLocked = true
        end
    end

end

local function changeMusic(e)
        local x
        local y
        x = btnSound.x
        y = btnSound.y
        btnSound:removeEventListener("tap",changeMusic)
        sceneGroup:remove(btnSound)

        if (withBackgroundMousic==true) then
            withBackgroundMousic = false
            btnSound = display.newImageRect(menuScreen.soundPlay, menuScreen.soundbuttonDimention, menuScreen.soundbuttonDimention)

            
            audio.stop()
        else 
            withBackgroundMousic = true
            btnSound = display.newImageRect(menuScreen.soundPause, menuScreen.soundbuttonDimention, menuScreen.soundbuttonDimention)
            
            playLoopSound( theme_sound,1, -1 , 0.3)

        end

        btnSound.x = x
        btnSound.y = y
        sceneGroup:insert(btnSound)
        btnSound:addEventListener("tap",changeMusic)
end


local function gotoPlay(e)
    currentLevel = e.target.idx
    storyboard.purgeScene("play")
    storyboard.removeScene("play")
    storyboard.gotoScene( "play", {effect="fade"} )

end

---------------------------------------------------------------------------------
-- BEGINNING OF YOUR IMPLEMENTATION
---------------------------------------------------------------------------------

-- Called when the scene's view does not exist:
function scene:createScene( event )
	local group = self.view
	sceneGroup = group

	local prior_scene = storyboard.getPrevious()
	storyboard.purgeScene( prior_scene )
	
	storyboard.purgeScene("play")
	storyboard.removeScene("play")

	--local myStagesBackground = display.newImage( menuScreen.LevelSelect_Background)
    --local background = display.newImageRect( menuScreen.LevelSelect_Background, 380, 570 )
    --myStagesBackground.x = centerX-- display.contentWidth/2--display.contentCenterX
    --myStagesBackground.y = centerY --display.contentHeight/2--display.contentCenterY
    --sceneGroup:insert(myStagesBackground) 

	
	--SOUNDS
    if (withBackgroundMousic==true) then
        btnSound = display.newImageRect(menuScreen.soundPause, menuScreen.soundbuttonDimention, menuScreen.soundbuttonDimention)
    else 
        btnSound = display.newImageRect(menuScreen.soundPlay, menuScreen.soundbuttonDimention, menuScreen.soundbuttonDimention)
    end
    btnSound.x = menuScreen.soundBtnXDimention-- 40--centerX
    btnSound.y = menuScreen.soundBtnYDimention -- display.contentHeight - 50
    sceneGroup:insert(btnSound)
    --group:insert(btnSound)
    btnSound:addEventListener("tap",changeMusic)
    --SOUNDS


	-----------------------------------------------------------------------------
		
	--	CREATE display objects and add them to 'group' here.
	--	Example use-case: Restore 'group' from previously saved state.
	
	-----------------------------------------------------------------------------

	--local bLabel = "English Alphabet"
	--local tapBtn = widget.newButton{label = bLabel, style = bStyle, onRelease=goAlphabet}
	
	
		    --SETUP LEVEL BUTTONS DYNAMICALLY
    loadPrefs()
    local startingY = menuScreen.levelsIconsYDimention + 25--150
    local yTimes = 0
    local lastLevelY = 0
    --or idx=1, stagesTotalNumber-1, 1 do

        print("stagesTotalNumber: " .. tostring(stagesTotalNumber))
        
        --for myIndex=idx, idx + 1 do
        for idx=(currentStage-1)*15 + 1, (currentStage-1)*20 + 1 + 15 - 3, 3 do
            print("idx " .. tostring(idx))
            local yDimention = (yTimes * 90) 
            local xTimes = 0
            --print("myIndex " .. myIndex)
            --print("levelsimages[myIndex].level " .. levelsimages[myIndex].level)
            local backgroundoflevel
            local level
            local mask
            for myIndex=idx, idx + 2 do
                if(((myIndex < 91) and (currentStage == 6)) or ((myIndex < 76) and (currentStage == 5)) or ((myIndex < 61) and (currentStage == 4)) or ((myIndex < 46) and (currentStage == 3)) or ((myIndex < 31) and (currentStage == 2)) or ((myIndex < 16) and (currentStage == 1))) then --elegxos min peraso to 33 level kai fao itta
                	backgroundoflevel = display.newImageRect(menuScreen.stagesimagesbackground, 80, 80)
                	backgroundoflevel.x = display.contentCenterX - 90  + xTimes*90

                    --level.y = 360
                    if yTimes == 0 then
                        --startingY
                        backgroundoflevel.y = startingY -- yDimention --+ 30--centerY - 110
                    else
                        backgroundoflevel.y = startingY + yDimention
                    end
                    sceneGroup:insert(backgroundoflevel)

                     level = display.newImageRect(stagesImages[1].image, 40, 40)
                     level.x = backgroundoflevel.x
                     level.y = backgroundoflevel.y
                     
					sceneGroup:insert(level)

                    print("levelLocked[myIndex] " .. tostring(myIndex) .. " -- " .. tostring(levelLocked[myIndex]))
                    if levelLocked[myIndex] == nil then levelLocked[myIndex] = true end

                    if not levelLocked[myIndex] then
                        level.alpha = 0.0
                        --display.newImage(levelsimages[myIndex].level)
                         --mask = graphics.newMask("assets/gfx/100/play2.png")
                        local lvleTxt = display.newText(tostring(myIndex) , 0 , 0 , native.systemFont, 22)
                       lvleTxt:setTextColor (255, 255, 255)
                       print("lvleTxt" .. tostring(lvleTxt))
                        lvleTxt.x = level.x-- - 10
                        lvleTxt.y = level.y - 15
                        --level:insert(lvleTxt)
                        sceneGroup:insert(lvleTxt)

                        for j=1, 3 do
                            local mystarimage = display.newImageRect("images/buttons/stargray.png", 15, 15)
                            mystarimage.x = lvleTxt.x - 14 +  ((j-1)*17) - 3
                            mystarimage.y = lvleTxt.y + 19-- - yDimention 
                            sceneGroup:insert(mystarimage)
                        end
                        local x = levelStars[currentLevel]
                        if x == nil then
                            x = 0
                        end
                        for j=1, x do
                            local  mystarimage = display.newImageRect("images/buttons/star.png", 15, 15)
                            mystarimage.x = lvleTxt.x - 14 +  ((j-1)*17) - 3
                            mystarimage.y = lvleTxt.y + 19-- - yDimention 
                            sceneGroup:insert(mystarimage)
                        end

                        local lvleScore = display.newText(tostring(levelScores[myIndex]) , 0 , 0 , native.systemFont, 10)
                        lvleScore:setTextColor (255, 255, 255)
                        lvleScore.x = level.x-- - 10
                        lvleScore.y = level.y + 21
                        --level:insert(lvleTxt)
                        sceneGroup:insert(lvleScore)

                    else
                        --level = display.newImage("assets/gfx/levelbutton3.png")
                    	level.alpha = 0.5

                        local lock = display.newImageRect(menuScreen.lock, 40,40)
                        lock.x = level.x 
                        lock.y = level.y
                        lock.alpha = 1
                        sceneGroup:insert(lock)
                        --mask = graphics.newMask("assets/gfx/100/mask2.png")
                    end
                    --level:setMask(mask) 

                   
                     

                    if not levelLocked[myIndex] then
                                print("testindex" .. tostring(myIndex))
                                backgroundoflevel.idx = myIndex
                                backgroundoflevel:addEventListener( "tap", gotoPlay )
                                --level:addEventListener("tap", function(e) 
                                --    composer.gotoScene( "src.levelSceneMine", {params ={currentClickedStage=myIndex}} )
                                --end)
                    else

                    end

                    xTimes = xTimes + 1
                end --if
           end --for myIndex=idx, idx + 2 do
        --end --end for
        yTimes = yTimes + 1
        lastLevelY = level.y 
    end --end for
    --END OF SETUP LEVEL BUTTONS

end


-- Called immediately after scene has moved onscreen:
function scene:enterScene( event )
	local group = self.view
	
	-----------------------------------------------------------------------------
		
	--	INSERT code here (e.g. start timers, load audio, start listeners, etc.)
	
	-----------------------------------------------------------------------------
	
	--print("Enterd");
end


-- Called when scene is about to move offscreen:
function scene:exitScene( event )
	local group = self.view
	
	-----------------------------------------------------------------------------
	
	--	INSERT code here (e.g. stop timers, remove listeners, unload sounds, etc.)
	
	-----------------------------------------------------------------------------
	
end


-- Called prior to the removal of scene's "view" (display group)
function scene:destroyScene( event )
	local group = self.view
	
	-----------------------------------------------------------------------------
	
	--	INSERT code here (e.g. remove listeners, widgets, save state, etc.)
	
	-----------------------------------------------------------------------------
	
end


---------------------------------------------------------------------------------
-- END OF YOUR IMPLEMENTATION
---------------------------------------------------------------------------------

-- "createScene" event is dispatched if scene's view does not exist
scene:addEventListener( "createScene", scene )

-- "enterScene" event is dispatched whenever scene transition has finished
scene:addEventListener( "enterScene", scene )

-- "exitScene" event is dispatched before next scene's transition begins
scene:addEventListener( "exitScene", scene )

-- "destroyScene" event is dispatched before view is unloaded, which can be
-- automatically unloaded in low memory situations, or explicitly via a call to
-- storyboard.purgeScene() or storyboard.removeScene().
scene:addEventListener( "destroyScene", scene )

---------------------------------------------------------------------------------

return scene